Guild_Channel_oldSendChatMessage = SendChatMessage
local function Guild_Channel_newSendChatMessage(msg, type, lang, chan)
	if (type == "GUILDCHANNEL") then
		local id, _ = GetChannelName(string.upper(Guild_Channel_Config.chan))
		if (id > 0) then
			local afk = GetCVar("autoClearAFK")
			SetCVar("autoClearAFK", 0)
			type = "CHANNEL"
			lang = nil
			chan = id
			SetCVar("autoClearAFK", afk)
		end
	end
	Guild_Channel_oldSendChatMessage(msg, type, lang, chan)
end
SendChatMessage = Guild_Channel_newSendChatMessage

local function Guild_Channel_notify(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
	Guild_Channel:debug(Guild_Channel_Config.chan)
	local chan = string.lower(arg6) -- used to be arg9
	if (string.find(chan, Guild_Channel.CHAN_CMD)) then
		if (arg1 == "CHANNEL_OWNER" or arg1 == "OWNER_CHANGED") then
			Guild_Channel.mod = arg2
			Guild_Channel:debug("Moderator is " .. Guild_Channel.mod)
		end
		return true
	end
	if (string.find(chan, Guild_Channel_Config.chan)) then
		return true
	end
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_NOTICE_USER", Guild_Channel_notify)
ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_JOIN", Guild_Channel_notify)
ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL_LEAVE", Guild_Channel_notify)

function Guild_Channel:Alias(chan)
	local id, _ = GetChannelName(chan)
	
	if id > 0 then
		ChatTypeInfo["GUILDCHANNEL"] = ChatTypeInfo["CHANNEL"..id]
		ChatTypeInfo["GUILDCHANNEL"].sticky = 1
	end

	_G["CHAT_MSG_GUILDCHANNEL"] = chan
	_G["CHAT_GUILDCHANNEL_GET"] = "["..chan.."] %s:\32"
	_G["CHAT_GUILDCHANNEL_SEND"] = "GC:\32"
	table.foreach(_G, function(k,v)
		if string.find(k, "SLASH") then
			if v == "/gc" then
				Guild_Channel:debug(k)
				_G[k] = nil
			end
		end
	end)
	
	_G["SLASH_GUILDCHANNEL1"] = "/gc"
end

function Guild_Channel:UnAlias(chan)
	if (DEFAULT_CHAT_FRAME.editBox.stickyType == "GUILDCHANNEL") then
		DEFAULT_CHAT_FRAME.editBox.chatType = "SAY"
		DEFAULT_CHAT_FRAME.editBox.stickyType = "SAY"
	end
	_G["CHAT_MSG_GUILDCHANNEL"] = nil
	_G["CHAT_GUILDCHANNEL_GET"] = nil
	_G["CHAT_GUILDCHANNEL_SEND"] = nil
	_G["SLASH_GUILDCHANNEL1"] = nil
end

local hooks = {}
local h = nil

local function AddMessage(frame, text, ...)
	text = gsub(text, "%[(%w+)%.%s(" .. Guild_Channel_Config.chan .. ")%]", "[GC]")
	return hooks[frame](frame, text, ...)
end

for i = 1, 7 do
	h = _G[("%s%d"):format("ChatFrame", i)]
	hooks[h] = h.AddMessage
	h.AddMessage = AddMessage
end
