local L = LibStub("AceLocale-3.0"):GetLocale("Guild_Channel", true)

local function explode(seperator, str)
	local pos, arr = 0, {}
	for st, sp in function() return string.find(str, seperator, pos, true) end do
		table.insert(arr, string.sub(str, pos, st-1))
		pos = sp + 1
	end
	table.insert(arr, string.sub(str, pos))
	return arr
end

function Guild_Channel:CHAT_MSG_CHANNEL_NOTICE(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
	Guild_Channel:debug("CHAT_MSG_CHANNEL_NOTICE")
	Guild_Channel:debug(arg1 or "")
	Guild_Channel:debug(arg9 or "")

	if (arg8 == 3) then
		Guild_Channel:ScheduleTimer(function () Guild_Channel:SendPosition() end, 5)
	end
	if (arg9 == Guild_Channel.CHAN_CMD and arg1 == "YOU_JOINED") then
		Guild_Channel:debug("joined cmd")
		Guild_Channel:SendPosition()
		DisplayChannelOwner(Guild_Channel.CHAN_CMD)
	end
	if (arg9 == Guild_Channel.CHAN_CMD and arg1 == "YOU_LEFT") then
		Guild_Channel:LeaveCmdChannel()
	end
	if (arg9 == Guild_Channel_Config.chan) then
		if (arg1 == "YOU_LEFT") then
			Guild_Channel:LeaveCmdChannel()
		elseif (arg1 == "YOU_JOINED") then
			Guild_Channel:debug("channel joined")
			Guild_Channel.chan_joined = true
			Guild_Channel.CHAN_CMD = Guild_Channel_Config.chan.."users"
			Guild_Channel:EnableChannel()
		end
	end
end

function Guild_Channel:CHAT_MSG_CHANNEL_LIST(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
	if (arg9 == Guild_Channel_Config.chan) then

		local player, _ = UnitName("player")
	
		for value in gmatch(arg1,"[^,]+") do
			local name = string.gsub(value, "^%s*\**@*(.-)%s*$", "%1")
			if (not Guild_Channel.PlayerList[name]) then
				Guild_Channel.count = Guild_Channel.count + 1
				Guild_Channel.PlayerList[name] = {}
				Guild_Channel.PlayerList[name].rank = 3
			end
		end
		
		if (not Guild_Channel.PlayerList[player]) then
			Guild_Channel.count = Guild_Channel.count + 1
			Guild_Channel.PlayerList[player] = {}
			Guild_Channel.PlayerList[player].rank = 3
		end
		
		Guild_Channel:SendCmdMsg("R") -- will only work on reload
		JoinChannelByName(Guild_Channel.CHAN_CMD, Guild_Channel.CHAN_CMD)
		DisplayChannelOwner(Guild_Channel.CHAN_CMD)
		
		if IsInGuild() then GuildRoster() end
		Guild_Channel:SendWho()

		Guild_Channel:Update()
	end
end

function Guild_Channel:CHAT_MSG_CHANNEL(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
	if (arg9 == Guild_Channel.CHAN_CMD) then
		local cmd = explode("#", arg1)
		if (cmd[1] == "P") then -- position
			if (Guild_Channel.PlayerList[arg2]) then
			 	Guild_Channel.PlayerList[arg2].rank = 2
			 	Guild_Channel.PlayerList[arg2].class = cmd[3]
			 	Guild_Channel.PlayerList[arg2].zone = cmd[5]
			 	Guild_Channel.PlayerList[arg2].level = cmd[4]
				Guild_Channel.PlayerList[arg2].main = cmd[2]
				Guild_Channel_Config.T[arg2] = cmd[2]
			end
		elseif (cmd[1] == "W") then -- whois
			if (Guild_Channel_Config.T[cmd[2]]) then
				Guild_Channel:SendCmdMsg("U#" .. cmd[2] .. "#" .. Guild_Channel_Config.T[cmd[2]])
			end
		elseif (cmd[1] == "U") then -- update
			Guild_Channel_Config.T[cmd[2]] = cmd[3]
		elseif (cmd[1] == "R") then -- ui reload
			Guild_Channel:SendPosition()
			if (GetGuildInfo("player") == Guild_Channel_Config.guild and Guild_Channel.motd and Guild_Channel.motd ~= "") then
				Guild_Channel:SendCmdMsg("M#" .. Guild_Channel.motd)
			end
		elseif (cmd[1] == "M") then -- motd
			if (GetGuildInfo("player") ~= Guild_Channel_Config.guild and cmd[2] ~= "") then
				Guild_Channel.motd = cmd[2]
			end
		elseif (cmd[1] == "RM") then -- request motd
			if (GetGuildInfo("player") == Guild_Channel_Config.guild and Guild_Channel.motd and Guild_Channel.motd ~= "") then
				Guild_Channel:SendCmdMsg("M#" .. Guild_Channel.motd)
			end
		elseif (cmd[1] == "K") then -- kick
			if (Guild_Channel.PlayerList[cmd[2]]) then
				ChannelKick(Guild_Channel_Config.chan, cmd[2]);
			end
		elseif (cmd[1] == "B") then -- ban
			if (Guild_Channel.PlayerList[cmd[2]]) then
				ChannelBan(Guild_Channel_Config.chan, cmd[2]);
			end
		elseif (cmd[1] == "UB") then -- unban
			if (Guild_Channel.PlayerList[cmd[2]]) then
				ChannelUnban(Guild_Channel_Config.chan, cmd[2]);
			end
		elseif (cmd[1] == "VERSION") then
			Guild_Channel:SendCmdMsg(GetAddOnMetadata("Guild_Channel", "Version"))
		elseif (cmd[1] == "CONFIG") then
			local guild = Guild_Channel_Config.guild or "nil"
			local main = Guild_Channel_Config.main or "nil"
			local chan = Guild_Channel_Config.chan or "nil"
			Guild_Channel:SendCmdMsg(guild .. "#" .. main .. "#" .. chan)
		end
		Guild_Channel:Update()
	end
end

function Guild_Channel:CHAT_MSG_CHANNEL_LEAVE(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
	if (arg9 == Guild_Channel_Config.chan) then
		local alt = ""
		if (Guild_Channel_Config.T[arg2] and Guild_Channel_Config.T[arg2] ~= arg2) then alt = " (" .. Guild_Channel_Config.T[arg2] .. ")" end
		if (UnitInRaid(arg2)) then
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ff9aGC|r: " .. arg2 .. alt .. L[" has gone offline."], 1, 0, 0)
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ff9aGC|r: " .. arg2 .. alt .. L[" has gone offline."])
		end
		if (Guild_Channel.PlayerList[arg2]) then Guild_Channel.count = Guild_Channel.count - 1 end
		Guild_Channel.PlayerList[arg2] = nil
		Guild_Channel:Update()
	end
end

function Guild_Channel:CHAT_MSG_CHANNEL_JOIN(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
	if (arg9 == Guild_Channel_Config.chan) then
		local alt = ""
		if (Guild_Channel_Config.T[arg2] and Guild_Channel_Config.T[arg2] ~= arg2) then alt = " (" .. Guild_Channel_Config.T[arg2] .. ")" end
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ff9aGC|r: |Hplayer:" .. arg2 .. "|h[" .. arg2.. "]|h" .. alt .. L[" is now online."])
		if (not Guild_Channel.PlayerList[arg2]) then Guild_Channel.count = Guild_Channel.count + 1 end
		Guild_Channel.PlayerList[arg2] = {}
		Guild_Channel.PlayerList[arg2].rank = 3
		Guild_Channel.newPlayer = true
		Guild_Channel:Update()
		if IsInGuild() then GuildRoster() end
	elseif (arg9 == Guild_Channel.CHAN_CMD) then
		Guild_Channel:SendPosition()
		local player, _ = UnitName("player")
		if (player == Guild_Channel.mod and Guild_Channel.motd) then
			Guild_Channel:SendCmdMsg("M#" .. Guild_Channel.motd)
		elseif (player == Guild_Channel.mod and not Guild_Channel.motd) then
			Guild_Channel:ScheduleTimer(function () Guild_Channel:SendCmdMsg("RM") end, 20)
		end
	end
end

function Guild_Channel:Update()
	Guild_Channel.ldb.text = "GC " .. Guild_Channel.count
	if IsAddOnLoaded("Guild_ChannelFu") then Guild_ChannelFu:UpdateFuBarPlugin() end
	if Guild_Channel.tt then Guild_Channel:DrawTooltip() end
end

function Guild_Channel:EnableChannel()
	Guild_Channel:Alias(Guild_Channel_Config.chan)
	ListChannelByName(Guild_Channel_Config.chan)
end

function Guild_Channel:LeaveCmdChannel()
	Guild_Channel.PlayerList = {}
	Guild_Channel.count = 0
	Guild_Channel:Update()
	Guild_Channel:UnAlias(Guild_Channel_Config.chan)
	LeaveChannelByName(Guild_Channel.CHAN_CMD)
	Guild_Channel.chan_joined = false
end

function Guild_Channel:SendPosition(level)
	if (GetGuildInfo("player") ~= Guild_Channel_Config.guild) then
		local player, class, _
		player, _ = UnitName("player")
		_, class = UnitClass("player");
		if (level == nil) then
			level = UnitLevel("player")
		end
		Guild_Channel:SendCmdMsg("P#" .. Guild_Channel_Config.main .. "#" .. class .. "#" .. level .. "#" .. GetRealZoneText())
	end
end

function Guild_Channel:SendCmdMsg(msg)
	local zoneChannel, _ = GetChannelName(Guild_Channel.CHAN_CMD)
	SendChatMessage(msg, "CHANNEL", nil, zoneChannel)
end
